package events
{
    import flash.events.Event;

    /**
     * Event to communicate changes to the global count.
     */
    public class CountEvent extends Event
    {
        public static const GLOBAL_UPDATE:String = "globalUpdateCountEvent";
        public static const LOCAL_UPDATE:String = "localUpdateCountEvent";
        public static const RESET:String = "resetCountEvent";

        /**
         * Constructor
         */
        public function CountEvent(type:String,
                                   newCount:int,
                                   bubbles:Boolean = true,
                                   cancelable:Boolean = false)
        {
            super(type, bubbles, cancelable);
            _newCount = newCount;
        }

        private var _newCount:int;
        /**
         * The new count value associated with this event.
         */
        public function get newCount():int
        {
            return _newCount;
        }

        /**
         * @private
         */
        override public function clone():Event
        {
            return new CountEvent(type, newCount, bubbles, cancelable);
        }
    }
}