package viewModels
{
    import events.CountEvent;

    import flash.events.Event;
    import flash.events.IEventDispatcher;

    /**
     * Default implementation of ISubCounterViewModel.
     */
    public class SubCounterViewModel extends ViewModelBase
                                     implements ISubCounterViewModel
    {
        private static const SUB_TOTAL_CHANGED:String = "subTotalChanged";
        private static const COUNT_CHANGED:String = "countChanged";

        //------------------------------------
        //
        //           Constructor
        //
        //------------------------------------

        /**
         * Constructor
         */
        public function SubCounterViewModel(dispatcher:IEventDispatcher)
        {
            super(dispatcher);
        }


        //------------------------------------
        //
        //           Properties
        //
        //------------------------------------

        //----------------------------------
        //  subTotal
        //----------------------------------

        private var _subTotal:int;
        [Bindable("subTotalChanged")]
        /**
         * @see ISubCounterViewModel.subTotal
         */
        public function get subTotal():int
        {
            return _subTotal;
        }
        /**
         * @private
         */
        public function set subTotal(value:int):void
        {
            if (value != _subTotal)
            {
                _subTotal = value;
                dispatchEvent(new Event(SUB_TOTAL_CHANGED));
            }
        }

        //----------------------------------
        //  count
        //----------------------------------

        private var _count:int;
        [Bindable("countChanged")]
        /**
         * @see ISubCounterViewModel.count
         */
        public function get count():int
        {
            return _count;
        }
        /**
         * @private
         */
        public function set count(value:int):void
        {
            if (value != _count)
            {
                _count = value;
                dispatchEvent(new Event(COUNT_CHANGED));
            }
        }


        //------------------------------------
        //
        //           Functions
        //
        //------------------------------------

        /**
         * @see ISubCounterViewModel.increaseCount
         */
        public function increaseCount():void
        {
            count++;
            subTotal++;

            // inform everyone else that the count has changed
            dispatchEvent(new CountEvent(CountEvent.LOCAL_UPDATE, _subTotal));
        }

        /**
         * @see ISubCounterViewModel.decreaseCount
         */
        public function decreaseCount():void
        {
            count--;
            subTotal--;

            // inform everyone else that the count has changed
            dispatchEvent(new CountEvent(CountEvent.LOCAL_UPDATE, _subTotal));
        }
    }
}