package viewModels
{
    import flash.events.Event;
    import flash.events.EventDispatcher;
    import flash.events.IEventDispatcher;

    /**
     * Base class for all presentation models.  Ensures that
     * events are dispatched appropriately.
     */
    public class ViewModelBase extends EventDispatcher
                               implements IViewModel
    {
        /**
         * Constructor
         */
        public function ViewModelBase(dispatcher:IEventDispatcher)
        {
            super();
            this.dispatcher = dispatcher;
        }

        /**
         * The dispatcher to use to ensure that Mate receives
         * the dispatched event.
         */
        public var dispatcher:IEventDispatcher;

        /**
         * @private
         */
        override public function dispatchEvent(event:Event):Boolean
        {
            if (dispatcher)
            {
                dispatcher.dispatchEvent(event);
            }
            return super.dispatchEvent(event);
        }
    }
}