package utils
{
    import flash.events.Event;
    import flash.events.IEventDispatcher;
    import flash.utils.Dictionary;

    import mx.collections.ArrayCollection;
    import mx.collections.ICollectionView;
    import mx.collections.IList;

    public class TestEventDispatcher implements IEventDispatcher
    {
        private var _dispatchedEvents:Dictionary = new Dictionary();
        public function get dispatchedEvents():Dictionary
        {
            return _dispatchedEvents;
        }

        private var _listeners:Dictionary = new Dictionary();
        public function get listeners():Dictionary
        {
            return _listeners;
        }

        public function addEventListener(type:String,
                                         listener:Function,
                                         useCapture:Boolean = false,
                                         priority:int = 0,
                                         useWeakReference:Boolean = false):void
        {
            var typeListeners:IList = listeners[type] as IList;
            if (!typeListeners)
            {
                typeListeners = new ArrayCollection();
                listeners[type] = typeListeners;
            }
            typeListeners.addItem(listener);
        }

        public function removeEventListener(type:String,
                                            listener:Function,
                                            useCapture:Boolean = false):void
        {
            var typeListeners:IList = listeners[type] as IList;
            if (typeListeners &&
                typeListeners.getItemIndex(listener) != -1)
            {
                typeListeners.removeItemAt(typeListeners.getItemIndex(listener));
            }
        }

        public function dispatchEvent(event:Event):Boolean
        {
            var events:IList =
                    dispatchedEvents[event.type] as IList;
            if (!events)
            {
                events = new ArrayCollection();
                dispatchedEvents[event.type] = events;
            }
            events.addItem(event);
            return true;
        }

        public function hasEventListener(type:String):Boolean
        {
            var typeListeners:IList = listeners[type] as IList;
            return typeListeners && typeListeners.length > 0;
        }

        public function willTrigger(type:String):Boolean
        {
            return hasEventListener(type);
        }

        public function clear():void
        {
            _dispatchedEvents = new Dictionary();
        }

        public function eventsForType(type:String):IList
        {
            return dispatchedEvents[type] as IList;
        }

        public function numberOfEventsForType(type:String):int
        {
            var events:IList = eventsForType(type) as IList;
            return events ? events.length : 0;
        }
    }
}